
public class EkipiOlimpik {

    //Deklarimi i atributeve (+ inicializimi i index)
    private String emri;
    private Sportisti[] sportistet;
    private int index = 0;

    //Konstruktori
    public EkipiOlimpik(String e, int nrS){
        emri = e;
        sportistet = new Sportisti[nrS];
    }

    //Metode per shtypjen e te gjithe sportisteve qe gjenden ne varg
    public void print(){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return;
        }

        for(int i = 0; i < index; i++){
            System.out.println(sportistet[i]);
        }
    }

    //Metoda qe tregon se a gjendet sportisti/ja i/e caktuar ne ekipin olimpik
    public boolean ekziston(Sportisti s){
        for(int i = 0; i < index; i++){
            if(s.equals(sportistet[i])){
                return true;
            }
        }
        return false;
    }

    //Metoda per te shtuar sportistin/en e caktuar ne ekip
    public void shtoSportistin(Sportisti s){
        if(s == null){
            System.out.println("Sportisti nuk eshte inicializuar!");
        }
        else if(index == sportistet.length){
            System.out.println("Nuk ka vend ne ekip per te shtuar sportistin/en: " + s + "!");
        }
        else if(ekziston(s)){
            System.out.println("Sportisti/ja: " + s + " vetem se gjendet ne ekip!"); 
        }
        else{
            sportistet[index++]=s;
        }
    }

    //Metoda per shtypjen e sportisteve sipas gjinise
    public void shtypSipasGjinise(char gj){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return;
        }

        for(int i = 0; i < index; i++){
            if(sportistet[i].getGjinia() == gj){
              System.out.println(sportistet[i]);
            }
        }
    }

    //Metoda qe kthen sportistin/en me te vjeter ne ekip
    public Sportisti meIVjetri(){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return null;
        }

        Sportisti sVjeter = null;
        for(int i = 0; i < index; i++){
            if(sVjeter == null || sVjeter.getMosha() < sportistet[i].getMosha()){
                sVjeter = sportistet[i];
            }
        }

        return sVjeter;
    }

    //Metoda qe kthen te gjithe sportistet, emri i te cileve/cilave fillon me parametrin e dhene
    public Sportisti[] ktheSipasEmrit(String param){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return null;
        }

        Sportisti[] spEmri = null;
        int count = 0;
        for(int i = 0; i < index; i++){
            if((sportistet[i].getEmri().toLowerCase()).startsWith(param.toLowerCase())){
                count++;
            }
        }

        if(count == 0){
            System.out.println("Ne kete ekip, asnje sportisti/eje nuk i fillon emri me: " + param);
            return null;
        }

        spEmri = new Sportisti[count];
        int pozita = 0;
        for(int i = 0; i < index; i++){
            if((sportistet[i].getEmri().toLowerCase()).startsWith(param.toLowerCase())){
                spEmri[pozita++] = sportistet[i];
            }
        }

        return spEmri;
    }

    //Metoda per largimin e nje sportisti/eje nga ekipi
    public boolean largoSportistin(Sportisti s){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return null;
        }

        for(int i = 0; i < index; i++){
            if(s.equals(sportistet[i])){
                for(int j = i; j < index-1; j++){
                    sportistet[j] = sportistet[j+1];
                }
                sportistet[--index] = null;
                i--;
                return true;
            }
        }

        return false;
    }

    public static void main(String [] args){

        EkipiOlimpik eKS = new EkipiOlimpik("Kosova Team", 25);

        Sportisti s1 = new Sportisti(202112345, "Vedat Muriqi", (byte)27, 'M');
        Sportisti s2 = new Sportisti(202113456, "Arijanet Muric", (byte)22, 'M');
        Sportisti s3 = new Sportisti(202148554, "Besjana Recica", (byte)25, 'F');
        Sportisti s4 = new Sportisti(202135858, "Valentina Limani", (byte)24, 'F');
        Sportisti s5 = new Sportisti(202139958, "Besarta Hisenaj", (byte)27, 'F');

        eKS.shtoSportistin(s1);
        eKS.shtoSportistin(s2);
        eKS.shtoSportistin(s3);
        eKS.shtoSportistin(s4);
        eKS.shtoSportistin(s5);

        System.out.println("Lista e te gjithe sportisteve te ekipit:");
        eKS.print();

        System.out.println("===========================================================================");

        Sportisti sProvo = new Sportisti(202198726, "Granit Xhaka", (byte)29, 'M');
        System.out.println((sProvo.getGjinia()=='M'?"Sportisti ":"Sportistja ") + sProvo + (eKS.ekziston(sProvo)? " ":"nuk") + " gjendet ne ekip!");

        System.out.println("===========================================================================");

        System.out.println("Sportistet femra:");
        eKS.shtypSipasGjinise('F');

        System.out.println("===========================================================================");

        System.out.println((eKS.meIVjetri().getGjinia()=='F'?"Sportistja e pare me e vjeter":"Sportisti i pare me i vjeter") + " ne ekip: " + eKS.meIVjetri());

        System.out.println("===========================================================================");

        System.out.println("Sportistet qe ju fillon emri me V:");
        Sportisti[] sV = eKS.ktheSipasEmrit("v");
        for (Sportisti sp : sV) {
            System.out.println(sp);
        }
        //Forme tjeter: for loop
        /**
         * for(int i = 0; i < sV.length; i++){
         *     System.out.println(sV[i]);
         * }
         */

        System.out.println("===========================================================================");

        System.out.println("Sportisti/ja " + s2 + (eKS.largoSportistin(s2)?" ":" nuk ") + " u fshi.");
        System.out.println("Sportisti/ja " + s3 + (eKS.largoSportistin(s3)?" ":" nuk ") + " u fshi.");

        System.out.println("===========================================================================");

        System.out.println("Lista e sportisteve te ekipit pas largimit:");
        eKS.print();
    }
}
